Type
  MG_FilNamTyp = String[14];

Function Exist(FileName : MG_FilNamTyp) : Boolean;
{    Checks for the presence of the DOS file name parameter on disk.
     This is the Exist routine that Borland describes in their TP manual.
   What they don't tell you (at least not in my version of the manual),
   is that without the close statement, calling the routine will suck up
   one of your file handles. This may not be a problem to a program which
   processes a single file, but will cause a multiple file program, which
   makes repeated calls to Exist, to go down in glorious flames in a hurry!
     I suppose the trade off is that with this version you must code an
   open statement for the file if Exist is TRUE. It does not leave the file
   open. That makes for an extra line of code, but facilitates the kind of
   logical statement with which I feel more comfortable: eg.:
       If it exists, then open it, otherwise tell the user it's not there.
}
Var
 Fil : file;
Begin
Assign(Fil,FileName);
{$I-}
Reset(Fil);
Close(Fil); {****}
{$I+}
Exist := (IOResult = 0);
End; {Exist}
