program orbit;
type
 ArrReal = array[1..10] of real;
label Endloop;
var
 m,
 ax,ay,
 vx,vy,vxo,vyo,
 x,y,xo,yo : ArrReal;
 i,j :integer;
 oldi,
 oldj,
 diam,
 scolor : array[1..10] of integer;
 ix,
 iy : integer;
 n : integer;
 f1,f2,d,d2,d3,dx,dy : real;
 firsttime : boolean;
 Chr1 : char;
type
  TSStr     = String[80];
  TSCharSet = set of char;
  TSDate    = String[6];
{Global variables}
var
  TSString  :  TSStr;
TSDefAttrib:  byte;    {Screen color attribute}
TSInsMode  :  boolean; {keeps track of the insert key}
{$I graph.p}  {From Turbo Pascal}
{$I a:SE.UTL}
{$I a:SEREAL.UTL}  {utilities for real variables. Delete if not needed}
{$I a:SEINT.UTL}  {utilities for real variables. Delete if not needed}
procedure PutTitleOrbit;
begin
    TextBackground(2);
    TextColor(15);
    ClrScr;
    Box(10,4,71,22,2,27,
       ':+:=!:+:=');
    PutVariableOrLabel(23,6,31,'Initial coordinates',19);
    PutVariableOrLabel(26,8,31,'x',1);
    PutVariableOrLabel(35,8,31,'y',1);
    PutVariableOrLabel(44,6,31,'Initial velocity',16);
    PutVariableOrLabel(64,6,31,'Mass',4);
    PutVariableOrLabel(47,8,31,'x',1);
    PutVariableOrLabel(55,8,31,'y',1);
    PutVariableOrLabel(64,8,31,'m',1);
    PutVariableOrLabel(15,10,31,'1',1);
    PutVariableOrLabel(15,12,31,'2',1);
    PutVariableOrLabel(15,14,31,'3',1);
    PutVariableOrLabel(15,16,31,'4',1);
    PutVariableOrLabel(15,18,31,'5',1);
    PutVariableOrLabel(12,6,31,'Star',4);
end; {of procedure}

procedure  OutVarOrbit(var Xo,Yo,Vx,Vy,M:ArrReal);
var
 I,YCoord : integer;
begin
  PutInteger(13,8,240,N,2);
   for I := 1 to 5 do
   begin
    YCoord := 8+2*i;
    PutReal(22,YCoord,240,Xo[i],
         6,1,0);
    PutReal(31,YCoord,240,Yo[i],
         6,1,0);
    PutReal(42,YCoord,240,Vx[i],
         6,1,2);
    PutReal(51,YCoord,240,Vy[i],
         6,1,2);
    PutReal(62,YCoord,240,m[i],
         6,1,2);
   end;
end;

procedure  InpVarOrbit(var Xo,Yo,Vx,Vy,M:ArrReal);
 {$V-}         {Do not remove this compiler directive
  it is required to disable type checking in this procedure}
 type
   TSCharSet = set of Char;
 var
   Chr1,Chr2  : Char;
   L,I,YCoord : Byte;
 Const
   End1 : TSCharSet = [^I,^M,#27,#10];
   End2 : TSCharSet = ['H','P',#15];
 begin
  OutVarOrbit(Xo,Yo,Vx,Vy,M);
  GetInteger(13,8,240,N,End1,End2,Chr1,Chr2,2,0,5);
  I := 1;        {Star counter}
  if Chr1 <> #10 then
  begin
    L  := 1;      {Initial condition counter}
    repeat
     YCoord := 8+2*I;
     case L of
       1 : GetReal(22,YCoord,240,Xo[I],End1,End2,Chr1,Chr2,
         6,1,0, -9.9998953500E+03,  9.9998953500E+04);
       2 : GetReal(31,YCoord,240,Yo[I],End1,End2,Chr1,Chr2,
         6,1,0, -9.9998953500E+03,  9.9998953500E+04);
       3 : GetReal(42,YCoord,240,Vx[I],End1,End2,Chr1,Chr2,
         6,1,2, -9.9998953500E+03,  9.9998953500E+04);
       4 : GetReal(51,YCoord,240,Vy[I],End1,End2,Chr1,Chr2,
         6,1,2, -9.9998953500E+03,  9.9998953500E+04);
       5 : GetReal(62,YCoord,240,m[I],End1,End2,Chr1,Chr2,
         6,1,2, -9.9998953500E+03,  9.9998953500E+04);
     end; {of case}
     if (Chr1 = ^I) or (Chr1 = ^M) or ((Chr1 = #27) and (Chr2 ='P')) then
      if L = 5 then
      begin
       L := 1;
       I := I + 1;
       if I > N then
       I := 1;
      end else L := L+1
    else
     if (Chr1 = #27) and ((Chr2 = 'H') or (Chr2 = #15)) then
      if L = 1 then
      begin
       L := 5;
       I := I -1;
       if I = 0 then
       I := N;
      end else L := L-1;
   until (((Chr1 = ^M) and (L = 1) and (I = 1))  or (Chr1 = #10) );

{$V+}
end;
end;

procedure  InpOrbit(var Xo,Yo,Vx,Vy,M:ArrReal);
begin

  PutTitleOrbit;
  InpVarOrbit(Xo,Yo,Vx,Vy,M);
end; {of procedure}

procedure  EditOrbit(var Xo,Yo,Vx,Vy,M: arrReal);
begin
  PutTitleOrbit;
  InpVarOrbit(Xo,Yo,Vx,Vy,M);

end; {of procedure}

procedure  OutOrbit(var Xo,Yo,Vx,Vy,M: ArrReal);

begin
  PutTitleOrbit;
  OutVarOrbit(Xo,Yo,Vx,Vy,M);

end; {of procedure}


begin
 TSInsMode   := false;
 TSDefAttrib :=  47;
 TextColor(15);
 TextBackground(1);
 ClrScr;
 GotoXY(1,1);
 writeln('This program solves approximately  the 2-d equations of motion of up to 5');
 writeln('celestial bodies. It was written by Pedro J. Restrepo, to be included');
 writeln('with the ScreenEngine design program. The program''s basic algorithm');
 writeln('for the 3-d problem was published in the January 1986 issue of');
 writeln('Scientific American');
 writeln('The data input screen was created with ScreenEngine and later edited.');
 writeln;
 writeln('While on the data input screen, use the [Up] or [Down] arrow, or the');
 writeln('[Tab] and [Shift] [Tab] keys to move the cursor around.');
 writeln('Pressing [Enter] after the last item, or [Ctrl] [Enter] anytime will');
 writeln('start the program. Experiment with the initial values and modify the');
 writeln('program at your convenience!');
 writeln('To stop the program, press [Esc] or [Ctrl][Break].');
 writeln('Any other key will return to the data input screen');
 writeln;
 Writeln('This program requires a computer with a Color Graphics Adapter');
 Write('Enter Y if your computer has one');
 Read(kbd,Chr1);
 if UpCase(Chr1) <> 'Y' then Halt;
   xo[1]  := 90.0;
   yo[1]  := 100.0;
   Vxo[1] := 0.0;
   VYo[1] := -0.10;
   m[1]   := 110.0;
   xo[2]  := 170.0;
   yo[2]  := 100.0;
   Vxo[2] := 0.0;
   VYo[2] := 0.70;
   m[2]   := 16.0;
   xo[3]  := 185.0;
   yo[3]  := 100.0;
   Vxo[3] := 0.0;
   VYo[3] := 1.30;
   m[3]   := 0.01;
   xo[4]  := 100.0;
   yo[4]  := 50.0;
   Vxo[4] := 0.70;
   VYo[4] := 0.20;
   m[4]   := 0.01;
   xo[5]  := 0.0;
   yo[5]  := 0.0;
   Vxo[5] := 0.0;
   VYo[5] := 0.0;
   m[5]   := 0.0;
  n := 4;
 repeat
  textmode;
  InpOrbit(Xo,Yo,Vxo,Vyo,M);

  for I := 1 to n do
  begin
   diam[i]  := round(sqrt(abs(m[i])));
   scolor[i] := i mod 3 + 1;
   x[i] := xo[i];
   y[i] := yo[i];
   vx[i] := vxo[i];
   vy[i] := vyo[i];
  end;
  graphmode;
  Palette(1);
  GraphBackground(0);
  firsttime := true;
  repeat
  for i := 1 to n do
  begin
  for j := i+1 to n do
  begin
     dx := x[i]-x[j];
     dy := y[i]-y[j];

     d2 :=  dx*dx + dy*dy;
     d  := sqrt(d2);
     d3 := d2*d;
     if round(d) <= diam[i]+diam[j] then
      begin write('BANG!!!!!');
       Chr1 := #27;
       Goto EndLoop;
     end;
     f1  := m[j]/d3;
     f2  := m[i]/d3;
     vx[i] := vx[i]  -f1*dx;
     vy[i] := vy[i]  -f1*dy;
     x[i]  := x[i] + vx[i];
     y[i]  := y[i] + vy[i];
     vx[j] := vx[j] + f2*dx;
     vy[j] := vy[j] + f2*dy;
     x[j]  := x[j] + vx[j];
     y[j]  := y[j] + vy[j];
end;
end;
  for I := 1 to n do
  begin
  circle(Oldi[i],oldj[i],diam[i],0);
   ix := 20+round(0.9*x[i]+0.5);
   iy := 20+round(0.9*y[i]+0.5);
   circle(ix,iy,diam[i],scolor[i]);
   oldi[i] := ix;
   oldj[i] := iy;
  end;
  firsttime := false;
 until keypressed;
EndLoop:
 read(kbd,Chr1);

until Chr1 = #27;
TextMode;
end.